<?php
/*
Plugin Name: Spam Trap
Plugin URI: http://spamtrap.ro/
Description: Scatters invisible links to spam traps email addresses throughout your wordpress blog to help collect and catch spam.
Author: Andrei Husanu
Author URI: http://husanu.bloq.ro/
Version: 0.2.3
*/

////////////////////////////////////////////////////////////////////////////

include dirname( __FILE__ ) . '/names.php';

function spamtrapro_getRandomString( $min = 6, $max = 20 ) 
{
	$cs = 'abcdefghijklmnopqrstuvwxyz';
	
	list( $usec, $sec ) = explode(' ', microtime( ) );
	$seed = ( float )$sec + ( ( float )$usec * 100000 );
	mt_srand( $seed );
	
	$string = '';
	$length = mt_rand( $min, $max );
	for( $p = 0; $p < $length; $p++ ) {
		$string .= $cs[ mt_rand( 0, strlen( $cs ) - 1 ) ];
	}
	
	return $string;
}

////////////////////////////////////////////////////////////////////////////////

function spamtrapro_wp_date( ) 
{
	return date( 'z' );
}

function spamtrapro_wp_dom( ) 
{
	if( isset( $_SERVER[ 'HTTP_HOST' ] ) ) {
		$t = $_SERVER[ 'HTTP_HOST' ];
		$t = base_convert( md5( $t ), 16, 26 );
		for( $idx = 0; $idx < strlen( $t ); $idx++ ) {
			if( ord( $t[ $idx ] ) < ord( 'a' ) ) {
				$t[ $idx ] = chr( ord( $t[ $idx ] ) + 65 ); 
			}
		}
		return substr( $t, 0, 3 );
	}
	
	return 'wp';
}

////////////////////////////////////////////////////////////////////////////////

	define( "SPAMTRAP_DOMAIN", "mailxu.com" );
	define( "SPAMTRAP_URL", "http://" . spamtrapro_wp_dom( ) . "." . SPAMTRAP_DOMAIN );
	define( "SPAMTRAP_SHOW_LINK", "SPAMTRAP_SHOW_LINK" );

	add_option( SPAMTRAP_SHOW_LINK, 0 );

////////////////////////////////////////////////////////////////////////////////

function spamtrapro_wp_generatemail( )
{	
	global $SPAMTRAP_NAMES;
	global $SPAMTRAP_SEP;
	global $SPAMTRAP_NAMES_2;
	
	$xday = mktime( date( 'H' ), 0, 0 ) / ( 3600 );
	
	$xname = $SPAMTRAP_NAMES[ $xday % count( $SPAMTRAP_NAMES ) ];
	if( mt_rand( 0, 1 ) == 0 ) {
		$xname .= $SPAMTRAP_SEP[ mt_rand( 0, count( $SPAMTRAP_SEP ) - 1 ) ];
		$xname .= $SPAMTRAP_NAMES_2[ mt_rand( 0, count( $SPAMTRAP_NAMES_2 ) - 1 ) ];
	} 
	else
	if( mt_rand( 0, 2 ) == 0 ) 
		$xname .= spamtrapro_wp_dom( );
	else
	if( mt_rand( 0, 2 ) == 0 )
		$xname .= spamtrapro_wp_date( );
	
	return $xname . "@" . SPAMTRAP_DOMAIN;
}

////////////////////////////////////////////////////////////////////////////////

	function spamtrapro_print_options_page()
	{
		$options_page = get_option( 'siteurl' ) . '/wp-admin/options-general.php?page=spamtrap/spamtrap.php';
		
		if( isset( $_POST[ 'Submit'] ) &&
			$_POST[ 'Submit' ] == 'Save' ) 
		{
			$v = 0;
			if( isset( $_POST[ SPAMTRAP_SHOW_LINK ] ) )
				$v = $_POST[ SPAMTRAP_SHOW_LINK ];
			update_option( SPAMTRAP_SHOW_LINK, $v );
		}
		
		?>
			<div class="wrap">
				<h2>SpamTrap Settings</h2>
				<p>
					Spamtraps are usually e-mail addresses that are created not for communication, 
					but rather to lure spam. In order to prevent legitimate email from being invited, 
					the e-mail address will typically only be published in a location hidden from view 
					such that an automated e-mail address harvester (used by spammers) can find the 
					email address, but no sender would be encouraged to send messages to the email 
					address for any legitimate purpose. Since no e-mail is solicited by the owner of 
					this spamtrap e-mail address, any e-mail messages sent to this address are 
					immediately considered unsolicited.
					<span class="description">
						( for more information read <a href="http://en.wikipedia.org/wiki/Spamtrap" target="_blank">here</a> )
					</span>
				</p>
				
				<form name="form1" method="post" action="<?php echo $options_page; ?>&amp;updated=true">
					<table width="100%" cellspacing="2" cellpadding="5" class="form-table">
						<tr valign="baseline">
							<th scope="row">Put a link to spamtrap?</th>
							<td>
								<?php
									$spamtrap_show_link = get_option( SPAMTRAP_SHOW_LINK );
									if( $spamtrap_show_link == 1) {
										echo "\n<input type=\"checkbox\" name=\"".SPAMTRAP_SHOW_LINK."\" value=\"1\" checked=\"checked\">\n";
									} else {
										echo "\n<input type=\"checkbox\" name=\"".SPAMTRAP_SHOW_LINK."\" value=\"1\">\n";
									} 
								?>
									link to <a href="<?php echo SPAMTRAP_URL; ?>" target="_blank"><?php echo SPAMTRAP_URL; ?></a>
								</input>
								<p><small>Behind this link there are web pages with random text and random email addresses.</small></p>
							</td>
						</tr>
					</table>
					<p class="submit">
						<input type="submit" name="Submit" value="Save" />
					</p>
				</form>
				
				<p>
					<span class="description">
						Email e.g.: <?php echo spamtrapro_wp_generatemail(); ?>
					</span>
				</p>
			</div>
		<?php
	}

	function spamtrapro_register_settings( ) {
	}
	
	function spamtrapro_create_menu( ) {
		add_options_page(
			'SpamTrap', 
			'SpamTrap', 
			'administrator', 
			__FILE__, 
			'spamtrapro_print_options_page'
		);
	}

	if ( is_admin( ) ) {
		add_action( 'admin_init', 'spamtrapro_register_settings' );
		add_action( 'admin_menu', 'spamtrapro_create_menu' );	
	}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

function spamtrapro_add_action_link( $links, $file ) 
{
	$settings_link = '<a href="options-general.php?page=spamtrap/options.php">' . __('Settings') . '</a>';
	array_unshift( $links, $settings_link ); 
	
	return $links;
}

$plugin = plugin_basename( __FILE__ );

add_filter( 'plugin_action_links_' . $plugin, 'spamtrapro_add_action_link', 10, 2 );

////////////////////////////////////////////////////////////////////////////

function spamtrapro_output_trap()
{
	$mail = spamtrapro_wp_generatemail( );
	
	$spamtrap_show_link = get_option( SPAMTRAP_SHOW_LINK );
	
	?>
	<div style="display: none;">
		<a href="mailto:<?php echo $mail; ?>"><?php echo $mail; ?></a>
		<?php
			if( $spamtrap_show_link == 1 ) {
				echo '<a href="' . SPAMTRAP_URL . '" target="_blank">' . SPAMTRAP_URL . '</a>';
			}
		?>
	</div>
	<?php
}

add_action( 'wp_footer', 'spamtrapro_output_trap' );

?>
